## ctpp2 2.8.3

=== CMakeLists.txt ===
#
# CTPP - C++ Template Engine
#
# Cmake configuration file
#
PROJECT(CTPP)

SET(CTPP_VERSION_MAJOR 2)
SET(CTPP_VERSION_MINOR 8)
SET(CTPP_VERSION_PATCH 3)

SET(CTPP_VERSION         "${CTPP_VERSION_MAJOR}.${CTPP_VERSION_MINOR}.${CTPP_VERSION_PATCH}")
SET(CTPP_IDENT           "Dzoraget")
SET(CTPP_MASTER_SITE_URL "http://ctpp.havoc.ru/")

CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)

OPTION(DEBUG_MODE          "Enable debug output [default: OFF]"                 OFF)
OPTION(ENABLE_OPTIMIZATION "Enable optimization [default: ON]"                  ON)
OPTION(SKIP_RELINK_RPATH   "Skip relinking and full RPATH for the install tree" OFF)

OPTION(ICONV_DISCARD_ILSEQ "Discard illegal sequence and continue (iconv) [default: ON]"    ON)
OPTION(ICONV_TRANSLITERATE "Enable transliteration in the conversion (iconv) [default: ON]" ON)

# Build optimized code for following CPU (default i386)
#SET(CPU_TUNE               "i686")

# Floating point precision for formatting output variables
SET(CTPP_FLOAT_PRECISION   12)

# Escape and tempoprary buffer size
SET(CTPP_ESCAPE_BUFFER_LEN 1024)

# Max. template recursion depth
SET(CTPP_MAX_TEMPLATE_RECURSION_DEPTH 1024)

# ################################################################################
# Standard library
#
OPTION(MD5_SUPPORT         "Enable md5 support [default: ON]"                   ON)
OPTION(ICONV_SUPPORT       "Enable iconv support [default: ON]"                 ON)

# ################################################################################
# Check Includes
#
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckLibraryExists)

CHECK_LIBRARY_EXISTS(m round    "" HAVE_ROUND_FN)
CHECK_LIBRARY_EXISTS(m roundl   "" HAVE_ROUNDL_FN)

CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/time.h  HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES(sys/uio.h   HAVE_SYS_UIO_H)

CHECK_INCLUDE_FILES(fcntl.h     HAVE_FCNTL_H)
CHECK_INCLUDE_FILES(math.h      HAVE_MATH_H)
CHECK_INCLUDE_FILES(stdio.h     HAVE_STDIO_H)
CHECK_INCLUDE_FILES(stdlib.h    HAVE_STDLIB_H)
CHECK_INCLUDE_FILES(string.h    HAVE_STRING_H)
CHECK_INCLUDE_FILES(strings.h   HAVE_STRINGS_H)
CHECK_INCLUDE_FILES(time.h      HAVE_TIME_H)
CHECK_INCLUDE_FILES(unistd.h    HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(sysexits.h  HAVE_SYSEXITS_H)

CHECK_CXX_SOURCE_COMPILES("#include <map>
                           namespace std { }
                           using namespace std;
                           int main(void)
                           {
                               map<int, int> m;
                               m.insert(pair<int, int>(1, 2));
                               m[2] = 3;
                               return 0;
                           }
                          " STL_MAP_CHECK)
IF(NOT STL_MAP_CHECK)
    MESSAGE(ERROR "!!!! STL map does not work!")
ENDIF(NOT STL_MAP_CHECK)

CHECK_CXX_SOURCE_COMPILES("#include <vector>
                           namespace std { }
                           using namespace std;
                           int main(void)
                           {
                               vector<int> v;
                               v.push_back(1);
                               return 0;
                           }
                          " STL_VECTOR_CHECK)
IF(NOT STL_VECTOR_CHECK)
    MESSAGE(ERROR "!!!! STL vector does not work!")
ENDIF(NOT STL_VECTOR_CHECK)

CHECK_CXX_SOURCE_COMPILES("#include <string>
                           using namespace std;
                           int main(void)
                           {
                               string s;
                               s.assign(\"Hello, World!\");
                               return 0;
                           }
                          " STL_STRING_CHECK)

IF(NOT STL_STRING_CHECK)
    MESSAGE(ERROR "!!!! STL string does not work!")
ENDIF(NOT STL_STRING_CHECK)

CHECK_CXX_SOURCE_COMPILES("#include <stdexcept>
                           namespace std { }
                           using namespace std;
                           int main(void)
                           {
                               try
                               {
                                   throw logic_error(\"Ouch!\");
                               }
                               catch(exception &e)
                               {
                                   return 0;
                               }
                               return 0;
                           }
                          " STL_STDEXCEPT_CHECK)

IF(NOT STL_STDEXCEPT_CHECK)
    MESSAGE(ERROR "!!!! STL logic_error/exception does not work!")
ENDIF(NOT STL_STDEXCEPT_CHECK)

CHECK_CXX_SOURCE_COMPILES("#include <vector>
                           int main(void)
                           {
                               vector<int> v;
                               v.push_back(1);
                               return 0;
                           }
                          " STL_VECTOR_NO_STD_CHECK)

IF (STL_VECTOR_NO_STD_CHECK)
    MESSAGE(STATUS "#### INFO: Using STL classes without STD namespace")
    SET(NO_STL_STD_PREFIX "ON")
ELSE (STL_VECTOR_NO_STD_CHECK)
    MESSAGE(STATUS "#### INFO: Using STL classes with STD namespace")
ENDIF (STL_VECTOR_NO_STD_CHECK)

MESSAGE(STATUS "#### System name is: ${CMAKE_SYSTEM_NAME}")

IF("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD")
    MESSAGE(STATUS "#### Building for FreeBSD...")
ENDIF("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD")

IF("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")

    SET(SKIP_ICONV_LIRARY   "ON")

    MESSAGE(STATUS "#### Building for Linux...")

    IF("${SKIP_RELINK_RPATH}" MATCHES "ON")
        SET(CMAKE_SKIP_RPATH  TRUE)

        MESSAGE(STATUS "#### Building for Linux...")
        # skip the full RPATH for the build tree
        SET(CMAKE_SKIP_BUILD_RPATH  TRUE)

        # when building, use the install RPATH already
        # (so it doesn't need to relink when installing)
        SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

        # the RPATH to be used when installing
        SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

        # add the automatically determined parts of the RPATH
        # which point to directories outside the build tree to the install RPATH
        SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    ENDIF("${SKIP_RELINK_RPATH}" MATCHES "ON")

ENDIF("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")

IF("${CMAKE_SYSTEM_NAME}" MATCHES "Darwin")
    SET(CMAKE_SKIP_RPATH FALSE)
    SET(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
    SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,-headerpad_max_install_names")
ENDIF("${CMAKE_SYSTEM_NAME}" MATCHES "Darwin")

IF("${CMAKE_SYSTEM_NAME}" MATCHES "SunOS")
    SET(SKIP_ICONV_LIRARY   "ON")
    MESSAGE(STATUS "#### Building for SunOS...")
ENDIF("${CMAKE_SYSTEM_NAME}" MATCHES "SunOS")

IF("${CMAKE_SYSTEM_NAME}" MATCHES "HP-UX")
    MESSAGE(STATUS "#### Building for HP-UX...")
ENDIF("${CMAKE_SYSTEM_NAME}" MATCHES "HP-UX")

SET(MD5_WITHOUT_OPENSSL "")
#
# MD5 library support
#
IF (${MD5_SUPPORT} MATCHES "ON")
    IF (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
        MESSAGE(STATUS "#### INFO: MD5 (Win32 CryptoAPI) hash function support enabled")
    ELSE (${CMAKE_SYSTEM_NAME} MATCHES "Windows")

        FIND_PATH(MD5_INCLUDE openssl/md5.h PATHS /opt/include
                                                  /usr/include
                                                  /usr/local/include
                  DOC "Path where the openssl header files can be found")

        IF (MD5_INCLUDE)
            INCLUDE_DIRECTORIES(${MD5_INCLUDE})

            FIND_LIBRARY(MD5_LIBRARY NAMES crypto PATHS /lib
                                                        /opt/lib
                                                        /usr/lib
                                                        /usr/local/lib
                         DOC "Path where the openssl libraries can be found")
            IF (MD5_LIBRARY)
                SET(PROJECT_LIBS "${PROJECT_LIBS} crypto")
            ELSE (MD5_LIBRARY)
                MESSAGE(STATUS "#### ERROR: Cannot find libcrypto.so, aborting")
            ENDIF (MD5_LIBRARY)

            SET(MD5_SUPPORT "ON")

            MESSAGE(STATUS "#### INFO: MD5 (openssl) hash function support enabled")

        ELSE (MD5_INCLUDE)
            # reset FIND_PATH
            SET(MD5_INCLUDE)
            FIND_PATH(MD5_INCLUDE md5.h PATHS /opt/include
                                              /usr/include
                                              /usr/local/include
                  DOC "Path where the openssl header files can be found")
            IF (MD5_INCLUDE)
                INCLUDE_DIRECTORIES(${MD5_INCLUDE})

                FIND_LIBRARY(MD5_LIBRARY NAMES md5 PATHS /lib
                                                         /opt/lib
                                                         /usr/lib
                                                         /usr/local/lib
                             DOC "Path where the md5 libraries can be found")
                IF (MD5_LIBRARY)
                    SET(PROJECT_LIBS "${PROJECT_LIBS} md5")
                    SET(MD5_SUPPORT         "ON")
                    SET(MD5_WITHOUT_OPENSSL "ON")
                    MESSAGE(STATUS "#### INFO: MD5 (libmd5) hash function support enabled")
                ELSE (MD5_LIBRARY)
                    MESSAGE(STATUS "#### ERROR: Cannot find md5.so, aborting")
                ENDIF (MD5_LIBRARY)
            ELSE (MD5_INCLUDE)
                SET(MD5_SUPPORT "")
                MESSAGE(STATUS "#### WARNING: MD5 hash function support disabled: md5.h not found")
            ENDIF (MD5_INCLUDE)

        ENDIF (MD5_INCLUDE)

    ENDIF (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
ENDIF (${MD5_SUPPORT} MATCHES "ON")

#
# Iconv converter support
#
IF (${ICONV_SUPPORT} MATCHES "ON")
    FIND_PATH(ICONV_INCLUDE iconv.h PATHS /opt/include
                                          /usr/include
                                          /usr/local/include
              DOC "Path where the iconv header files can be found")

    IF (ICONV_INCLUDE)
        INCLUDE_DIRECTORIES(${ICONV_INCLUDE})

        IF (NOT "${SKIP_ICONV_LIRARY}" MATCHES "ON")
            FIND_LIBRARY(ICONV_LIBRARY NAMES iconv PATHS /lib
                                                         /opt/lib
                                                         /usr/lib
                                                         /usr/local/lib
                         DOC "Path where the openssl libraries can be found")
            IF (ICONV_LIBRARY)
                SET(PROJECT_LIBS "${PROJECT_LIBS} iconv")
            ELSE (ICONV_LIBRARY)
                MESSAGE(STATUS "#### ERROR: Cannot find libiconv.so, aborting")
            ENDIF (ICONV_LIBRARY)
        ENDIF (NOT "${SKIP_ICONV_LIRARY}" MATCHES "ON")

        SET(ICONV_SUPPORT "ON")
        MESSAGE(STATUS "#### INFO: ICONV converter support enabled")

    ELSE (ICONV_INCLUDE)

        SET(ICONV_SUPPORT "")
        MESSAGE(STATUS "#### WARNING: ICONV converter support disabled: iconv.h not found")

    ENDIF (ICONV_INCLUDE)
ENDIF (${ICONV_SUPPORT} MATCHES "ON")

IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    FIND_LIBRARY(WS2_32_LIBRARY NAMES ws2_32)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

INCLUDE_DIRECTORIES(include)
INCLUDE_DIRECTORIES(include/functions)

IF("${CMAKE_COMPILER_IS_GNUCXX}" MATCHES "1")

    SET(CMAKE_CXX_PARAMS      " --param large-function-growth=5000 --param inline-unit-growth=600 -finline-limit=2000 ")

    SET(CMAKE_CXX_WARN_FLAGS  " -Wall -pedantic -Wno-long-long -Wno-inline -finline-functions ")

    IF(ENABLE_OPTIMIZATION MATCHES "ON")
        SET(CMAKE_CXX_FLAGS "${CXX_FLAGS} ${CMAKE_CXX_WARN_FLAGS} ${CMAKE_CXX_PARAMS} -O3 ")

        IF (NOT "${CPU_TUNE}" STREQUAL "")
            SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -mtune=${CPU_TUNE} ")

=== FreeBSD/textproc/ctpp2/Makefile ===
# New ports collection makefile for:   ctpp2
# Date created:         25 Jan 2008
# Whom:                 reki@reki.ru (Andrei V. Shetuhin)
#
# $FreeBSD: ports/textproc/ctpp2/Makefile,v 1.27 2010/08/04 07:44:02 lwhsu Exp $
#

PORTNAME=	ctpp2
PORTVERSION=	2.8.3
CATEGORIES=	textproc devel
MASTER_SITES=	http://ctpp.havoc.ru/download/

MAINTAINER=	reki@reki.ru
COMMENT=	C++ library to use templates in C/C++ projects, version 2

USE_CMAKE=	yes
USE_LDCONFIG=	yes
USE_GETTEXT=	yes
USE_ICONV=	yes

PLIST_SUB+=	PORTVERSION=${PORTVERSION}

MAN1=	ctpp2c.1 ctpp2vm.1 ctpp2i.1 ctpp2json.1 ctpp2-config.1

.include <bsd.port.mk>

=== debian/changelog ===
ctpp2 (2.8.3-26build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:02:56 +0100

ctpp2 (2.8.3-26) unstable; urgency=medium

  * Update my email address
  * Configure Salsa pipeline
  * Update symbols for hppa, ia64, kfreebsd-amd64, sh4

 -- Kunal Mehta <legoktm@debian.org>  Sun, 30 Dec 2018 08:42:19 +0000

ctpp2 (2.8.3-25.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "makes ctpp2 randomly FTBFS, syntax errors, hides problems":
    add patch from Paolo Greppi to fix wrongly escaped docstrings which cause
    intermittent build failures.
    (Closes: #886120)

 -- gregor herrmann <gregoa@debian.org>  Sun, 02 Dec 2018 20:49:09 +0100

ctpp2 (2.8.3-25) unstable; urgency=medium

  * Update symbols file for all release and ports architecture.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sat, 11 Aug 2018 21:21:28 +0530

ctpp2 (2.8.3-24) unstable; urgency=medium

  [ Kunal Mehta ]
  * Add myself as an uploader
  * Update symbols file
    Closes: #897732. Thanks to Mathias Klose.

  [ Vasudev Kamath ]
  * Fix an error in patch 1003.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sat, 11 Aug 2018 17:47:49 +0530

ctpp2 (2.8.3-23) unstable; urgency=medium

  * Update symbols file for all architectures.
  * Drop libctpp2-2v5-dbg package in favor of automatic debug symbol package.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sat, 19 Aug 2017 12:23:47 +0530

ctpp2 (2.8.3-22) unstable; urgency=medium

  * Stop pre-depend on multiarch-support.
    Closes: Bug#870507. Thanks to Aurelien Jarno.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 18 Aug 2017 20:30:10 +0200

ctpp2 (2.8.3-21) unstable; urgency=medium

  [ Vasudev Kamath ]
  * Acknowledge NMU by John Paul Adrian Glaubitz.

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Use License-Grant and License-Reference fields.
      Thanks to Ben Finney.
    + Use https protocol in file format URL.
    + Add coverage for myself.
  * Override lintian regarding license in License-Reference field.
    See bug#786450.
  * Bump debhelper compatibility level to 9.
  * Modernize Vcs-* fields: Use git (not cgit) in path.
  * Declare compliance with Debian Policy 4.0.1.
  * Fix Build-Depends-Indep (not Build-Depends) on graphviz.
  * Tighten major version resolving used for our packaging.
  * Modernize cdbs: Do copyright-check in maintainer script (not during
    build).
    Stop build-depend on licensecheck.
  * Advertise DEP3 format in patch headers.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 18 Aug 2017 16:49:25 +0200

ctpp2 (2.8.3-20.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbols file for alpha, hppa,
    hurd-i386, s390x and x32. Closes: bug#856162.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Mon, 27 Feb 2017 11:07:54 +0100

ctpp2 (2.8.3-20) unstable; urgency=medium

  * Update symbols for various architectures.
    Closes: bug#856162. Thanks to Adrian Bunk.
  * Fix typo in the short description.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sun, 26 Feb 2017 12:59:39 +0530

ctpp2 (2.8.3-19) unstable; urgency=medium

  * Update symbols file for amd64 architecture.
    Closes: bug#831203, Thanks to Lucas Nussbaum.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sat, 16 Jul 2016 18:41:31 +0530

ctpp2 (2.8.3-18) unstable; urgency=medium

  * Update symbols file for gcc-6 release.
    Closes: bug#811963, Thanks to Martin Michlmayr.
  * debian/control:
    + Mark package as compliant with Debian policy 3.9.8
    + Change my email address in Maintainer field
    + Use secure https URL for Vcs-Git field.
    + Use secure Cgit URL for Vcs-Browser field.

 -- Vasudev Kamath <vasudev@copyninja.info>  Sun, 03 Jul 2016 16:30:10 +0530

ctpp2 (2.8.3-17) unstable; urgency=medium

  * Update symbols file to build on all architecture.
  * Bump S-V to 3.9.6, no change required to source.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 06 Sep 2015 22:14:43 +0530

ctpp2 (2.8.3-16) unstable; urgency=medium

  * Fix FTBFS with GCC5, introduces library transition (Closes: bug#791016)
  * Tighten build-depends on d-shlibs to 0.61, needed for --v5 option.
  * Remove autogenerated doxygen files, only required for faster doc
    regeneration.

 -- Vasudev Kamath <vasudev@copyninja.info>  Fri, 21 Aug 2015 21:32:40 +0530

ctpp2 (2.8.3-15) unstable; urgency=medium

  * Update symbols file for amd64 release.
    Closes: bug#759950, Thanks to Lucas Nussbaum.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 07 Sep 2014 20:24:15 +0530

ctpp2 (2.8.3-14) unstable; urgency=medium

  * Updated symbols file for powerpc architecture.
    Closes: bug#754638, Thanks to Cyril Brulebois.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 20 Jul 2014 23:27:45 +0530

ctpp2 (2.8.3-13) unstable; urgency=medium

  * Add support for ppc64el in symbols file.
    Closes: bug#752411, Thanks to Breno Leitao.
  * Update symbol file for amd64.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 20 Jul 2014 18:13:25 +0530

ctpp2 (2.8.3-12) unstable; urgency=medium

  * Update symbols file for kfreebsd-amd64 architecture.
    Closes: bug#754638, Thanks to Cyril Brulebois.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 13 Jul 2014 20:18:36 +0530

ctpp2 (2.8.3-11) unstable; urgency=medium

  * Update symbols file for all architecture

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 22 Jun 2014 22:26:01 +0530

ctpp2 (2.8.3-10) unstable; urgency=medium

  [ Vasudev Kamath ]
   * Update symbols file for mips64el architecture.
     Closes: bug#748950, Thanks to Sphinx Jiang.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Sun, 15 Jun 2014 00:59:24 +0530

ctpp2 (2.8.3-9) unstable; urgency=medium

  * Update symbols file for ppc64 architecture.
    Closes: bug#743755, Thanks to Hiroyuki Yamamoto.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Mon, 07 Apr 2014 20:28:57 +0530

ctpp2 (2.8.3-8) unstable; urgency=medium



=== debian/control ===
Source: ctpp2
Section: libs
Priority: optional
Build-Depends: cdbs,
 debhelper,
 dh-buildinfo,
 cmake,
 d-shlibs (>= 0.61~),
 pkg-kde-tools
Build-Depends-Indep: doxygen, graphviz
Maintainer: Vasudev Kamath <vasudev@copyninja.info>
Uploaders: Jonas Smedegaard <dr@jones.dk>,
 Kunal Mehta <legoktm@debian.org>
Standards-Version: 4.1.5
Homepage: http://ctpp.havoc.ru/en
Vcs-Git: https://salsa.debian.org/debian/ctpp2.git
Vcs-Browser: https://salsa.debian.org/debian/ctpp2

Package: ctpp2-utils
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Tools for ctpp template conversion
 CTPP is a suitable choice for projects where a programmer and an HTML
 designer are different people. The goal of CTPP development was to
 achieve maximum performance with minimal basic functionality that is
 easily expandable. In other words, any conceivable capabilities can
 be added by writing users functions.
 .
 This package provides following tools to deal with ctpp templates:
  * ctpp2c - CTPP template compiler
  * ctpp2i - CTPP template interpreter
  * ctpp2-config - CTPP configuration tool
  * ctpp2json - CTPP JSON file parser
  * ctpp2vm - CTPP virtual machine

Package: ctpp2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: HTML template engine for C++ - documentation
 CTPP is a suitable choice for projects where a programmer and an HTML
 designer are different people. The goal of CTPP development was to
 achieve maximum performance with minimal basic functionality that is
 easily expandable. In other words, any conceivable capabilities can be
 added by writing users functions.
 .
 This package contains API manual.

Package: libctpp2-2v5
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: ctpp2-utils
Conflicts: libctpp2-2
Replaces: libctpp2-2
Multi-Arch: same
Description: HTML template engine for C++
 CTPP is a suitable choice for projects where a programmer and an HTML
 designer are different people. The goal of CTPP development was to
 achieve maximum performance with minimal basic functionality that is
 easily expandable. In other words, any conceivable capabilities can be
 added by writing users functions.
 .
 CTPP has following advantages over other template engines:
  * Very High performance as this is written in C++
  * Flexible syntax of templates
  * Robustness
  * Portability
  * Support for implementations in the language your choice
  * Various template sources
  * Output data filters
  * User functions

Package: libctpp2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libctpp2-2v5 (= ${binary:Version}),
 ${devlibs:Depends},
 ${misc:Depends}
Suggests: ctpp2-doc
Description: HTML template engine for C++ (development)
 CTPP is a suitable choice for projects where a programmer and an HTML
 designer are different people. The goal of CTPP development was to
 achieve maximum performance with minimal basic functionality that is
 easily expandable. In other words, any conceivable capabilities can be
 added by writing users functions.
 .
 This package provides header files for developing your applications to
 use ctpp2 template engine.
 .
 These header files allows you to utilize the library in your code to
 utilize the ctpp2 template engine.

=== debian/rules ===
#!/usr/bin/make -f

# This needs to declared/run before including CDBS snippets
stem = $(DEB_SOURCE_PACKAGE)
major := $(shell grep -Po '^SET\b.\bCTPP_VERSION_MAJOR +\K\d+' CMakeLists.txt)
# TODO: drop v5 suffix when major version > 1
libpkgname = lib$(stem)-$(major)v5
debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in::
	sed -e 's/__LIBPKGNAME__/$(libpkgname)/g' <debian/control.in.in >debian/control.in

include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

libname = lib$(stem)
devpkgname = lib$(stem)-dev
docpkgname = $(stem)-doc
utilspkg = $(stem)-utils

# Build Dependencies
CDBS_BUILD_DEPENDS +=, cmake

# Handle Upstream releases
DEB_UPSTREAM_URL = http://ctpp.havoc.ru/download/
DEB_UPSTREAM_TARBALL_MD5 = 1155b65e8ca8b844c631831e4a3e5644

# Upstream used flags
CXX_PARAMS = --param large-function-growth=5000 --param inline-unit-growth=600 -finline-limit=2000
CXX_WARN_FLAGS = -Wno-long-long -Wno-inline -finline-functions
CXXFLAGS += $(CXX_PARAMS) $(CXX_WARN_FLAGS)

# Install files for ctpp2-utils
DEB_DH_INSTALL_ARGS_$(utilspkg) = usr/bin/*
DEB_INSTALL_MANPAGES_$(utilspkg) = debian/tmp/usr/man/man1/*

# Install documentation
DEB_INSTALL_DOCS_$(stem)-doc += doc/html

# use standard LDFLAGS
DEB_CMAKE_NORMAL_ARGS += -DCMAKE_EXE_LINKER_FLAGS="${LDFLAGS}" -DCMAKE_SHARED_LINKER_FLAGS="${LDFLAGS}"

# Disable libssl linking
DEB_CMAKE_NORMAL_ARGS += -DMD5_SUPPORT=0

# Drop -dbg package in favor of auto generated -dbgsym
DEB_DH_STRIP_ARGS = --dbgsym-migration="$(libpkgname)-dbg (<< 2.8.3-23~)"

# Upgrade Doxyfile, and use SVG graphics
DEB_COMPRESS_EXCLUDE_DEFAULT += .xhtml
common-configure-indep:: debian/stamp-doxyupgrade
debian/stamp-doxyupgrade:
	[ ! -f /usr/bin/doxygen ] || ( set -e; \
		cp ${DEB_SRCDIR}/Doxyfile ${DEB_SRCDIR}/Doxyfile.orig; \
		doxygen -u ${DEB_SRCDIR}/Doxyfile; \
		perl -i -pe 's/DOT_IMAGE_FORMAT\K.*/=svg/;s/HTML_FILE_EXTENSION\K.*/=.xhtml/' ${DEB_SRCDIR}/Doxyfile; \
	)
	touch $@
clean::
	[ ! -f ${DEB_SRCDIR}/Doxyfile.orig ] || \
		cp ${DEB_SRCDIR}/Doxyfile.orig ${DEB_SRCDIR}/Doxyfile
	rm -f ${DEB_SRCDIR}/Doxyfile.bak
	rm -f debian/stamp-doxyupgrade

# Build Documentation
common-build-indep:: debian/stamp-docs
debian/stamp-docs:
	[ ! -f /usr/bin/doxygen ] || doxygen ${DEB_SRCDIR}/Doxyfile
	touch $@
clean::
	rm -f debian/stamp-docs

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
#  * Recent version needed for v5 option
# TODO: drop v5 option when major version > 2
CDBS_BUILD_DEPENDS +=, d-shlibs (>= 0.61~)
binary-post-install/$(libpkgname) binary-post-install/$(devpkgname):: debian/stamp-local-shlibs-$(libname)
debian/stamp-local-shlibs-$(libname): binary-install/$(libpkgname) binary-install/$(devpkgname)
	d-shlibmove --commit \
		--v5 \
		--devunversioned \
		$(if $(DEB_HOST_MULTIARCH),--multiarch) \
		--exclude-la \
		--override s/$(libname)-$(major)-dev/$(libname)-dev/ \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/$(libname).so
	touch $@
clean::
	rm -f debian/stamp-local-shlibs-$(libname)

# Remove the jquery
binary-post-install/$(docpkgname)::
	find debian/$(docpkgname)/usr/share/doc/$(docpkgname)/html/ -name "*.md5" -exec rm -vf {} \;

# track symbols using pkgkde-symbolshelper
CDBS_BUILD_DEPENDS +=, pkg-kde-tools
include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk

=== debian/watch ===
version = 3
http://ctpp.havoc.ru/download/ctpp2-(.*)\.tar\.gz
